﻿using Sitecore.SecurityModel;
using Sitecore.Shell.Applications.WebEdit.Commands;
using Sitecore.Shell.Framework.Commands;
using Sitecore.Web;
using Sitecore.Web.UI.HtmlControls;

namespace Skillcore.PersonalizationPreview.Commands
{
    public class TogglePersonalizationPreview : WebEditCommand
    {
        public override void Execute(CommandContext context)
        {
            PersonalizationPreviewContext.Current.Toggle();
            Reload(GetUrl());
        }

        public override string GetHeader(CommandContext context, string header)
        {
            return PersonalizationPreviewContext.Current.Enabled ? "Preview enabled" : "Preview disabled";
        }

        public override CommandState QueryState(CommandContext context)
        {
            if (!CanWebEdit() || !Policy.IsAllowed("Page Editor/Can Design"))
                return CommandState.Hidden;

            if (WebUtil.GetQueryString("mode") != "preview" || context.Items.Length > 0 && !WebEditUtil.CanDesignItem(context.Items[0]) || Registry.GetString("/Current_User/Page Editor/Capability/" + "design", "on") == "off")
                return CommandState.Disabled;

            if (!PersonalizationPreviewContext.Current.Allowed)
            {
                return CommandState.Hidden;
            }

            if (!PersonalizationPreviewContext.Current.Enabled)
            {
                return CommandState.Enabled;
            }

            return CommandState.Down;
        }
    }
}