﻿using System.Collections.Generic;
using System.IO;
using Sitecore.Mvc.ExperienceEditor.Pipelines.RenderPageExtenders;

namespace Skillcore.PersonalizationPreview.Pipelines.MvcRenderPageExtenders
{
    public class InjectScripts : RenderPageExtendersProcessor
    {
        private readonly IList<string> _scripts = new List<string>();

        public void AddScript(string script)
        {
            _scripts.Add(script);
        }

        public override void Process(RenderPageExtendersArgs args)
        {
            Render(args.Writer);
        }

        protected override bool Render(TextWriter output)
        {
            foreach (string script in _scripts)
            {
                output.Write(Sitecore.Web.HtmlUtil.GetClientScriptIncludeHtml(script));
            }
            return true;
        }
    }
}